<?php
//Temporary Credentials Request Endpoint

require_once ("HTTP/OAuth/Provider/Request.php");
require_once ("HTTP/OAuth/Provider/Response.php");
require_once("utils/bdUtils.php");
require_once("utils/ldapUtils.php");
require_once("utils/criptoUtils.php");


$request = new HTTP_OAuth_Provider_Request();
// Recibe:
// oauth_consumer_key
// oauth_signature_method
// oauth_signature
// oauth_timestamp
// oauth_callback
// scope
// admin
$name=$request->oauth_consumer_key;
$timestamp = $request->oauth_timestamp;
$callback = $request->oauth_callback;
$scope = $request->scope;
$timeTemp = $request->timeTemp;

$response = new HTTP_OAuth_Provider_Response;
// Verifica firma y Credenciales
$clientKey = getClientKey($name);
if($clientKey==null){
	$response->setStatus(HTTP_OAuth_Provider_Response::STATUS_INVALID_SIGNATURE);
	$response->send();
	die(0);
}else{
	//almacenar("callback", $request->oauth_callback, $id);
	// Check signature from consumer secret

	if ($request->isValidSignature($clientKey)) {		
		$response->setStatus(HTTP_OAuth_Provider_Response::STATUS_INVALID_SIGNATURE);
		$response->send();
		die(0);
	}else{
		// Return request_token
		$tempCred = assignTempCredentials($name, $timestamp, $scope, $callback, $timeTemp);
		$response->oauth_token = $tempCred['token'];
		$response->oauth_token_secret = $tempCred['secret'];
		$response->send();		
	}	
}

//Funciones Auxiliares
function assignTempCredentials($name, $timestamp, $scope, $callback, $timeTemp){
	$bd = new liteBD();
	$res = array();
	$res['token'] = generateTempKey();
	$res['secret'] = rand_str();
        $timestamp += $timeTemp;
	$bd->storeTempCredentials($res['token'], $res['secret'], $name, $timestamp, $scope,$callback);
	return $res;
}


function getClientKey($name){
	$res=null;
	$bd = new liteBD();
	if($bd->isRegistered($name)){
		$res = $bd->getKeyByName($name);
	}	
	return $res;
	
}




?>

